/****************************************************************
 *								*
 * Overrating costing program 	       				*
 *								*
 * File: costing.c	main code      				*
 *								*
 * Author: W. Langdon 
 *								*
 * Started: 23 Oct 1994 					*
 *								*
 ****************************************************************/

#define version "24 Oct 1994 $Revision: 1.8 $"

/********************** Just comment out wanted part ***************
/*Includes main function*/

#include <stdio.h>
#include <assert.h>
#include "loadflow.h"

/*Modifications (in reverse order)

WBL 23 Oct 94  
*/


#define rating  0.85

/* ABS gives the modulus of the given argument */
#define ABS(x)  ((x)>=0? (x) : -(x))
/*
void Display (int nn, int nl, int w, int* NNLK, int* NNLJ,
	      float* FLOW, float* IMBALANCE, float* LINERATING, BOOL* MAINT,
	      float cost, float shed )
{
	int i, j, k;
	
	printf ("\t\t\tDC Loadflow Results Week %2d\n",w);
	printf ("\t\t\t---------------------------\n\n\n");
	printf ("\tLine No.\tFrom Bus\tTo Bus\t\tFlows\t\tLoading\n\n");
	
	for (i=1; i<=nl; i++) {
	   float LOAD;
	   k = NNLK[i];
	   j = NNLJ[i];
	   LOAD = ABS(FLOW[i]/LINERATING[i]) * 100;
	   printf("\t%d\t\t%d\t\t%d\t\t%f\t\t%3.1f%%",i,k,j,FLOW[i],LOAD);
	   if(MAINT[i]) printf(" M");
	   printf("\n");
	}

        printf ("\n\tBus No.            Imbalance\n\n");
        for (i=1; i<=nn; i++) {
                printf ("\t%d\t\t%4.1fMW\n",i,IMBALANCE[i]);
        }

	printf("\t\t\t%4.1fMW\t\t\t%f\n", shed, cost);
	return;
}


/* This function reads the network parameters in from the study
 * file. It is however very simple, and may NOT detect errors 
 * within the study file *-
void ReadParameters (char filename[32], 
int* nn, int* nl, int*nw, float P[NW][NN], int* NNLK, int* NNLJ, float* XL,
float* LINERATING,
BOOL MAINT[NW][NL] )
{
	FILE *record;
	int w, i;

/* filename is provided by GetStudyName below *-
	record = fopen(filename,"r");

	fscanf(record,"%i %i %i", nn, nl, nw);

	if((*nn)>NN) *nn = NN;
	if((*nl)>NL) *nl = NL;
	if((*nw)>NW) *nw = NW;

	for (w=1; w<=*nw; w++) {
	for (i=1; i<=*nn; i++) {
	   fscanf(record,"%f", &P[w][i]);
/*	   printf("P[%d][%d] %f\n",w,i,P[w][i]);*-
	}
	}

	for (i=1; i<=*nl; i++) {
	   char c[80]; 
	   fscanf(record,"%i %i %f %f %s",
		  &NNLK[i], &NNLJ[i], &XL[i], &LINERATING[i], c);
/*	   printf("c[%d] %d\n",0,c[0]);*-
	   for(w=1;w<=*nw;w++) {
		   MAINT[w][i] = (c[0]=='m'||c[0]=='M') ? TRUE : FALSE; }
/*	   printf("MAINT[%d][%d] %d\n",1,i,MAINT[1][i]);*-
	}
	
	fclose(record);

	return;
}

/* Function obtains a study file name from the program operator *-
void GetStudyName (char filename[32])
{
	FILE *record;

	printf ("\nEnter name of study file: ");
	scanf ("%s",filename);
	printf ("\n");

/* Checks to ensuree the file name given is valid *-
	record = fopen(filename,"r");

	if (record == NULL) {
	   printf ("\nerror: failed to open study file '%s'\n",filename);
	   exit (0);
	}
}/*end GetStudyName*/

float Costing(int nl, float* LOAD, float* LINERATING)
{
int i;
float cost = 0.0;

for ( i = 1; i<= nl; i++){
	float over;
	over = ABS(LOAD[i]) - (LINERATING [i] * rating);
        if ( over > 0.0 ) cost += over;
     }
return cost;
}
/*
float Load_sheding(int nn, float* IMBALANCE)
{
int i;
float shed = 0.0;

for ( i = 1; i<= nn; i++){
	if ( IMBALANCE[i] < 0.0 ) shed += - IMBALANCE[i];
     }
return shed;
}

/**********************************************************************/
/* Routines and data shared by main                                   */
/**********************************************************************/

/* The globals below store the network parameters *-
int NNLK[NL], NNLJ[NL], nn, nl, nw;
BOOL MAINT[NW][NL];
float LINERATING[NL];

float P[NW][NN];

/* The globals below are used for storing the output data *-
float XL[NL], FLOW[NL];
float IMBALANCE[NN];

void Costweek() {
int w, j, k;
float c, shed;
float total_c = 0.0;
float total_shed = 0.0;

	for (w=1; w<=nw; w++) {
	Loadflow (nn, nl, P[w], NNLK, NNLJ, XL, MAINT[w], FLOW, IMBALANCE); 
        c = Costing (nl, FLOW, LINERATING); 
	total_c += c;
        shed = Load_sheding(nn, IMBALANCE); 
	total_shed += shed;
	Display (nn, nl, w, 
		 NNLK, NNLJ, FLOW, IMBALANCE, LINERATING, MAINT[w], c, shed); 
        }
	for(j=1;j<=nw;j++)
	 {
		 for(k=1;k<=nl;k++) 
			 {if(MAINT[j][k])printf("%1d",k);}
		 if(j<nw)printf(",");
         }
	printf(" %6.0f %6.0f\n", total_c, total_shed);

}/*end Costweek*/
/*
void dummycost() {
	int j, k;
	for(j=1;j<=nw;j++)
	 {
		 for(k=1;k<=nl;k++) 
			 {if(MAINT[j][k])printf("%1d",k);}
		 printf(",");
         }
	printf(".\n");
}/*end dummycost*/
/*
void recurse ( int line, const int* available ) {
int i;
for (i=0; i <= nw-line; i++)
{
MAINT[available[i]][line] = TRUE;

if ( line >= nl )
	Costweek();
else 
   {
	int new_available [ nw-line ];
	memcpy ( new_available, available, i*sizeof(int));
	memcpy ( &new_available[i], &available[i+1],(nw-line-i)*sizeof(int));

	recurse ( line+1, new_available );
   }
MAINT[available[i]][line] = FALSE;
}
}/*end recurse*/

/* Performs program as described by above functions *-
int main() {

char filename[32];

const int avail[9] = {1,2,3,4,5,6,7,8,9};

printf ("Program to calculate linecosts of a maintenance schedule, ");
printf ("Version %s\n", version);

GetStudyName (filename);

ReadParameters (filename, &nn, &nl, &nw, P, NNLK, NNLJ, XL, LINERATING,MAINT);

nw=1;
Costweek();

/*assert(nw<=9);
assert(nl<nw);

memset(MAINT,0,sizeof(MAINT));

recurse(1,avail);
*/
/*
MAINT[9][1] = TRUE;
MAINT[9][2] = TRUE;
MAINT[9][3] = TRUE;
MAINT[9][4] = TRUE;
MAINT[9][5] = TRUE;
MAINT[9][6] = TRUE;
MAINT[9][7] = TRUE;
MAINT[9][8] = TRUE;

Costweek();
*-

return 1;
}/*end main*/

