/*
Date:    Sun, 11 Feb 1996 08:37:09 EST
To:      W.Langdon@cs.ucl.ac.uk

From:    netlib server <netlibd@research.att.com>
Subject: Re: execute f2c
*/

/*  -- translated by f2c (version 19951025).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"
#include "loadflow.h"

/* *********************************************************************** */

/* CODA code mudules - contains routies: */

/* LTCOEF */
/* CIRCIT */
/* ASSCO         Removed WBL 20-jan-96 */

/* *********************************************************************** */

/* Title:        LTCOEF.FOR */
/* Version:      1.0 */
/* Author:       D. Waterhouse (using original code from ESCORT) */
/* Abstract:     Form load transfer coefficients and decide which */
/*               constraints may be rejected on the grounds that they */
/*               could never become active. Also prepare data for */
/*               calculating the effect of post-fault actions. */
/* Last Updated: 5.12.95 */
/* Hack by WBL   16.1.96 to get to add Dans 11/1/96 changes */
/*         WBL   20.1.96 pass all paramters by argument not common block */

/* *********************************************************************** */

/* Called from: CODA.FOR */
/* Calls to:    CIRCIT.FOR */

/* *********************************************************************** */

/* Common variables initialised or changed: */
/*    BASLIN NFREE NUMCF NUMCON OLDNCF OUTLIN */
/* Common variables read only: */
/*    BLINE CONECT LIMIT NB NDAT NN NODE NOD1 NOD2 Q RELAX */

/* *********************************************************************** */

void ltcoef(int lin, int nn, 
	    double susc[NL], int nod1[NL], int nod2[NL],
	    int numout, int kout[NL], int miss[NL],
	    double xx[NN*2], double flow[NL],
	    int ntovar[NN], double q[NN*NN/2], 
	    /* outputs */
	    double flownw[NL])
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    doublereal d__1;

    /* Local variables */
    static integer j, k, m, n;
    static doublereal alpha[1333]	/* was [31][43] */, alpha0[1333]	
	    /* was [31][43] */;
    static integer ir, is, ns;
    static doublereal oldpar[1892]	/* was [44][43] */, newpar[1892]	
	    /* was [44][43] */, bnr, bns, flowpas;


/*      INCLUDE 'PARAM' */
/* 23 Jan 96	Boost MXCLIN from 9 to 43 (NL in loadflow.h) */
/* 21 Jan 96	make MAXN agree with NN is loadflow.h */
/*      INCLUDE 'MAIN' */
/*      COMMON /MAIN/ XX */
/*      INCLUDE 'CONROW' */
/* PFALIM to store post-fault action limits */
/* OVDLIN, PREVI (,2) to store short-term and continuous const details */
/* NNCTYP, CNSTYP to store constraint type and PFAUSE the PFA number. */
/* Add PREVOV for use in SECURE */
/*      COMMON /CONROW/ CONPT, */
/*     * Basic data */
/*      INCLUDE 'CONT' */
/*      COMMON /CONT/ LIN,FLOW,NN,SUSC,NOD1,NOD2,NTOVAR */


/* Q is only defined in invrse, ltcoef - it can then be overlayed */
/*      COMMON /INVADM/ Q */

/*     * note that no more than MXCLIN simultaneous outages are allowed */
/* WBL      DOUBLE PRECISION OLDOLD(0:MXCLIN,MXCLIN,0:MXCLIN) */

/*     * Note this is a local SMALLA not same as SDRS2 one. Does same */
/*     * stuff, not obvious why a separate one is used. */


/*        * Calculate ALPHA0 */
    /* Function Body */
    i__1 = numout;
    for (k = 1; k <= i__1; ++k) {
	ir = nod1[kout[k]];
	if (ntovar[ir] < 0) {
	    ir = 0;
	} else {
	    ir = ntovar[ir];
	}

	is = nod2[kout[k]];
	if (ntovar[is] < 0) {
	    is = 0;
	} else {
	    is = ntovar[is];
	}

	i__2 = nn;
	for (ns = 1; ns <= i__2; ++ns) {
	    if (ntovar[ns] < 0) {
		alpha0[ns + k * 31 - 32] = 0.;
	    } else {
		n = ntovar[ns];
		if (ir == 0) {
		    bnr = 0.;
		} else if (n > ir) {
		    bnr = q[n * (n - 1) / 2 + ir];
		} else {
		    bnr = q[ir * (ir - 1) / 2 + n];
		}

		if (is == 0) {
		    bns = 0.;
		} else if (n > is) {
		    bns = q[n * (n - 1) / 2 + is];
		} else {
		    bns = q[is * (is - 1) / 2 + n];
		}
/*                 * DEFINE LOAD-TRANSFER COEFFICIENTS FOR OUT
AGE OF */
/*                 * BRANCH KOUT */
		alpha0[ns + k * 31 - 32] = susc[kout[k]] * (bnr - bns);
	    }
/* L45: */
	}
/* L40: */
    }

/*        * Initialise beta's & phi's */
    i__1 = numout;
    for (k = 1; k <= i__1; ++k) {
	i__2 = numout;
	for (j = 1; j <= i__2; ++j) {
	    oldpar[j + k * 44 - 44] = alpha0[nod1[kout[j]] + k * 31 - 32] - 
		    alpha0[nod2[kout[j]] + k * 31 - 32];
/* L70: */
	}

	if ((d__1 = 1. - oldpar[1], abs(d__1)) < 1e-10) {
/*              * Contingency splits the network */
	    goto L20;
	}
	oldpar[k * 44 - 44] = oldpar[k * 44 - 43] / (1. - oldpar[1]);
/* L60: */
    }

/* Retain values of OLDPAR in OLDOLD for the 1-line-out case. The 3rd */
/* dimension of OLDOLD keeps a track on the number of lines out for the */
/* calculated OLDPAR. These are required for the maths in LTCPFA. Values 
*/
/* for the >1-line case are stored later. */

/*         DO 80 J = 0, NUMOUT */
/*            DO 90 K = 1, NUMOUT */
/*               OLDOLD (J,K,0) = OLDPAR(J,K) */
/*   90       CONTINUE */
/*   80    CONTINUE */

/*        * calculate new beta's & phi's from old values */
    i__1 = numout;
    for (m = 2; m <= i__1; ++m) {
/*           * calculate beta's */
	i__2 = numout;
	for (j = m; j <= i__2; ++j) {
	    i__3 = numout;
	    for (k = 1; k <= i__3; ++k) {
		newpar[j + k * 44 - 44] = oldpar[j + k * 44 - 44] + oldpar[j 
			+ (m - 1) * 44 - 44] * oldpar[m - 1 + k * 44 - 44] / (
			1. - oldpar[m - 1 + (m - 1) * 44 - 44]);
/* L115: */
	    }
/* L110: */
	}

	if ((d__1 = 1. - newpar[m + m * 44 - 44], abs(d__1)) < 1e-10) {
	    goto L20;
	}

/*           * Calculate phi for j=m-1 */
	i__2 = numout;
	for (k = 1; k <= i__2; ++k) {
	    newpar[m - 1 + k * 44 - 44] = newpar[m + k * 44 - 44] / (1. - 
		    newpar[m + m * 44 - 44]);
/* L120: */
	}

/*           * Calculate remaining phi's */
	i__2 = m - 2;
	for (j = 0; j <= i__2; ++j) {
	    i__3 = numout;
	    for (k = 1; k <= i__3; ++k) {
		newpar[j + k * 44 - 44] = oldpar[j + k * 44 - 44] + newpar[m 
			- 1 + k * 44 - 44] * oldpar[j + m * 44 - 44];
/* L135: */
	    }
/* L130: */
	}

/*           * Update OLDPAR */
	i__2 = numout;
	for (j = 0; j <= i__2; ++j) {
	    i__3 = numout;
	    for (k = 1; k <= i__3; ++k) {
		oldpar[j + k * 44 - 44] = newpar[j + k * 44 - 44];
/*                 * Retain OLDPAR values in OLDOLD, as they a
re */
/*                 * recalculated every time a line is removed
.  12/92 */
/* WBL 20-jan                  OLDOLD(J,K,M-1) = OLDPAR(J,K) 
*/
/* L145: */
	    }
/* L140: */
	}

/* L100: */
    }

/*        * Calculate alpha's from OLDPAR (phi's) */
    i__1 = numout;
    for (k = 1; k <= i__1; ++k) {
	i__2 = nn;
	for (n = 1; n <= i__2; ++n) {
	    alpha[n + k * 31 - 32] = alpha0[n + k * 31 - 32];
	    i__3 = numout;
	    for (m = 1; m <= i__3; ++m) {
		alpha[n + k * 31 - 32] += oldpar[m - 1 + k * 44 - 44] * 
			alpha0[n + m * 31 - 32];
/* L154: */
	    }
/* L152: */
	}
/* L150: */
    }

/* Find new flows in non-contingent lines */

    i__1 = lin;
    for (k = 1; k <= i__1; ++k) {
	flownw[k] = flow[k];
	if (! miss[k]) {
	    i__2 = numout;
	    for (n = 1; n <= i__2; ++n) {
		if (ntovar[nod1[kout[n]]] <= 0) {
		    flowpas = -xx[ntovar[nod2[kout[n]]]];
		} else if (ntovar[nod2[kout[n]]] <= 0) {
		    flowpas = xx[ntovar[nod1[kout[n]]]];
		} else {
		    flowpas = xx[ntovar[nod1[kout[n]]]] - xx[ntovar[nod2[kout[
			    n]]]];
		}
		flownw[k] += susc[k] * flowpas * (alpha[nod1[k] + n 
			* 31 - 32] - alpha[nod2[k] + n * 31 - 32]);
/* L156: */
	    }
	} else {
	    flownw[k] = (float)0.;
	}
/* L153: */
    }

/* Check each remaining line to see if it can become overloaded */
/* ------------------------------------------------------------ */
/* removed WBL 20 Jan 1996 */


/*        * Jump here when contingency is rejected due to outaged line */
L20:
/* L10: */

/* If too many constraints of coefficients required (as counted above), */
/* give warning and stop run. */
/* removed WBL 20 Jan 1996 */

} /* ltcoef_ */

/* *********************************************************************** */

/* Title:        CIRCIT.FOR */
/* Version:      1.0 */
/* Author:       D. Waterhouse (using original code from ESCORT) */
/* Abstract:     Set up fault contingencies in arrays for LTCOEF. Need to */
/*               watch for lines on outage. Find which contingency outages */
/*               are applicable to the current network, by eliminating any */
/*               which have one or more lines on outage. Outage is */
/*               indicated by LINEIN = False. */
/* Last Updated: 5.12.95 */
/*          WBL 20.1.96  Replace common blocks by arguments */
/* *********************************************************************** */

/* Called from: LTCOEF */

/* *********************************************************************** */

/* Subroutine */ int circit_(contin, nclist, linein, intcon, conpt, conlin)
logical1 *contin;
integer *nclist;
logical *linein, *intcon;
shortint *conpt, *conlin;
{
    /* Format strings */
    static char fmt_9010[] = "(\0020\002,\002*** ERROR *** Too many lines in\
 contingencies. \002,\002Reduce problem size or ask for larger program limit.\
\002/\002 \002,\002              Contingency\002,i4,\002 ignored.   \002,a16)"
	    ;

    /* System generated locals */
    shortint s__1, s__2;
    integer i__1, i__2;

    /* Builtin functions */
    /* Subroutine  int s_copy();
    integer s_wsfe(), do_fio(), e_wsfe();
    /* Subroutine  int s_stop(); WBL*/

    /* Local variables */
    static logical match;
/*    static char reason[10*1000]; WBL*/
    static integer icount, numout[1000], icl, ick;
    static shortint ipk, ipt, num;
    static char out[1*1000];

    /* Fortran I/O blocks */
    static cilist io___25 = { 0, 7, 0, fmt_9010, 0 };




/*      INCLUDE 'PARAM' */
/* 23 Jan 96	Boost MXCLIN from 9 to 43 (NL in loadflow.h) */
/* 21 Jan 96	make MAXN agree with NN is loadflow.h */
/*      INCLUDE 'CONT' */
/*      COMMON /CONT/ NCLIST */
/*      INCLUDE 'MAIN' */
/*      COMMON /MAIN/ LINEIN */
/*      INCLUDE 'CONROW' */
/*      COMMON /CONROW/ INTCON, CONPT, CONLIN */
/*     * Basic data */

/* Arguments */

/* Local */

/* Determine which contingencies are to be applied */

    /* Parameter adjustments */
    --conlin;
    --conpt;
    --intcon;
    --linein;
    --contin;

    /* Function Body */
    icount = 0;
    i__1 = *nclist;
    for (icl = 1; icl <= i__1; ++icl) {
/*        * Check each line in contingency for outage. */
	contin[icl] = TRUE_;
/*	s_copy(reason + (icl - 1) * 10, "Intact", 10L, 6L); WBL*/
	num = conpt[icl + 1] - conpt[icl];
	numout[icl - 1] = num;
	s__1 = (shortint) (conpt[icl + 1] - 1);
	for (ipt = conpt[icl]; ipt <= s__1; ++ipt) {
	    *(unsigned char *)&out[ipt - 1] = ' ';
	    if (! linein[conlin[ipt]]) {
		contin[icl] = FALSE_;
/*		s_copy(reason + (icl - 1) * 10, "Lines out", 10L, 9L);WBL*/
		*(unsigned char *)&out[ipt - 1] = '*';
		--numout[icl - 1];
	    }
/* L20: */
	}

/*        * If contingency allowed to be incomplete, check if the line
s */
/*        * removed have made it the same as another contingency. If s
o, */
/*        * the first one wins and the second is removed. */
	if (! intcon[icl] && ! contin[icl]) {
/*           * Check all previous allowed contingencies */
	    match = FALSE_;
	    i__2 = icl - 1;
	    for (ick = 1; ick <= i__2; ++ick) {
/*              * Check each line in previous contingency that
 is in */
/*              * and has the same number of intact lines. */
		if (contin[ick] && numout[ick - 1] == numout[icl - 1]) {
		    s__1 = (shortint) (conpt[ick + 1] - 1);
		    for (ipk = conpt[ick]; ipk <= s__1; ++ipk) {
			if (linein[conlin[ipk]]) {
/*                       * Check each line in this
 contingency */
			    match = FALSE_;
			    s__2 = (shortint) (conpt[icl + 1] - 1);
			    for (ipt = conpt[icl]; ipt <= s__2; ++ipt) {
				if (conlin[ipt] == conlin[ipk]) {
				    match = TRUE_;
				    goto L51;
				}
/* L50: */
			    }
L51:
/*                      * Jump to next contingency
 at first unmatched line*/
			    if (! match) {
				goto L41;
			    }
			}
/* L40: */
		    }
L41:
/*                 * Exit checking at first match */
		    if (match) {
			contin[icl] = FALSE_;
/*WBL		       s_copy(reason + (icl - 1) * 10, "Duplicate", 10L, 9L);*/
			goto L31;
		    }
		}
/* L30: */
	    }
L31:
/*           * If no match among previous contingencies, allow thi
s one */
	    if (! match) {
/*              * Debug seems like overkill but could be helpf
ul */
		contin[icl] = TRUE_;
/*		s_copy(reason + (icl - 1) * 10, "Unique", 10L, 6L);WBL*/
	    }
	}

/* L99: */

/*        * defensive code check: reject if total lines out too many. 
*/
/*        * Can't continue if this is wrong, so unlikely that STOP is 
OK. */
	icount += num;
	if (icount > 1000) {
/*	    s_wsfe(&io___25); WBL*/
	    i__2 = icl - 1;
/*WBL	    do_fio(&c__1, (char *)&i__2, (ftnlen)sizeof(integer));
  	    do_fio(&c__1, "CONNAM(ICL-1)", 13L);
  WBL*/
            printf("*** ERROR *** Too many lines in contingencies. \n");
            printf("Reduce problem size or ask for larger program limit.\n");
            printf("               Contingency%4d ignored.   %s\n",
                   i__2, "CONNAM(ICL-1)");
/*WBL	    e_wsfe();
	    contin[icl] = FALSE_;
	    s_copy(reason + (icl - 1) * 10, "*Overflow*", 10L, 10L);
	    s_stop("999", 3L);
	    e_wsfe();
*WBL*/	    contin[icl] = FALSE_;
	    exit(999);
	}

/* L10: */
    }


    return 0;
} /* circit_ */

#ifdef uNdEfInEd
comments from the converter:  (stderr from f2c)
   ltcoef:
   circit:
#endif
