/* *********************************************************************** */
/* NETCHK    AN INDEPENDENT CHECK OF NETWORK CONNECTIVITY - IDENTIFIES     */
/*           CIRCUITS WHICH ARE NOT CONNECTED                              */
/*           NOTE THAT THIS SUBROUTINE WILL NOT DETECT UNCONNECTED NODES.  */
/* HIST WRITTEN BY D.J.ANELLI /11/87  BASED ON CODING TECHNIQUE PICKED UP  */
/*      FROM MIKE DILKS VIA PAUL PLUMPTRE AND THE ELPH PROGRAM.            */
/* *********************************************************************** */

/* $Revision: 1.3 $*/

/*Modifications (in reverse order)

WBL 13 Nov 94  Make compatible with other code from Mike Calviou

WBL 12 Nov 94  netchk.for translated by f2c (version 19941108).
*/

#include "loadflow.h"

/* Table of constant values */

BOOL netchk(int nl, int NNLK[NL], int NNLJ[NL], BOOL MAINT[NL], BOOL print)
{
    /* System generated locals */
    int i__1, i__2, i__3, i__4, i__5, i__6;

    /* Local variables */
    int next, k, n;
    int found, k1, n1, n2, ib;
    int lt1, ibf, ltf, ltk;
    int nsplit;   /* CURRENT NUMBER OF UNCONNECTED SUB-NETWORKS         */
		  /* THIS IS AN IDEA OF DJA'S.                          */
    int ltag[nl]; /* ALL CONNECTED CIRCUITS END UP WITH THE SAME TAG NO */



/*      INCLUDE 'PARAM.FOR' */
/*      INCLUDE 'NUM.FOR' */
/*      INCLUDE 'GEN.FOR' */
/*      INCLUDE 'NOD.FOR' */
/*      INCLUDE 'NTK.FOR' */


    /* Function Body */
    n = 0;
    nsplit = 0;

    i__1 = nl;
    for (ib = 1; ib <= i__1; ++ib) {
	if (!MAINT[ib]) {
	    n1 = NNLK[ib];
	    n2 = NNLJ[ib];
	    found = 0;
/*           * look for connections to this circuit */
	    i__2 = ib - 1;
	    for (k = 1; k <= i__2; ++k) {
		if (!MAINT[k]) {
		    if (NNLK[k] == n1 || NNLJ[k] == n1) {
			found = n1;
			next = n2;
			ibf = k;
		    } else if (NNLK[k] == n2 || NNLJ[k] == n2) {
			found = n2;
			next = n1;
			ibf = k;
		    }
		    if (found > 0) {
			goto L20;
		    }
		}
/* L10: */
	    }
L20:

	    if (found == 0) {
/*              * this circuit not yet connected to rest */
		++n;
		ltag[ib] = n;
		++(nsplit);
	    } else {
		ltf = ltag[ibf];
		ltag[ib] = ltf;

/*              * now look for connections to the other end */
		i__2 = ib - 1;
		for (k = ibf + 1; k <= i__2; ++k) {
		    if (!MAINT[k] && (NNLK[k] == next || NNLJ[k] == 
			    next)) {
			if (ltag[k] != ltf) {
/*                       * join these two portions
 of the network */
			    ltk = ltag[k];
			    --(nsplit);
			    i__3 = ib;
			    for (k1 = 1; k1 <= i__3; ++k1) {
				if (!MAINT[k1] && ltag[k1] == ltk) {
				    ltag[k1] = ltf;
				}
/* L40: */
			    }
/*                    else - already connected */
			}
		    }
/* L30: */
		}

	    }
	}
/* L100: */
    }

return (nsplit>1)? FALSE : TRUE; 

} /*end netchk */

