/* *********************************************************************** */
/* Find whether any single nodes are isolated by the group.                */
/* This is needed as NETCHK does not find nodes split from the system      */
/* (by having no lines). A single isolated node is correct as long         */
/* as there are no islands                                                 */
/* *********************************************************************** */

/* $Revision: 1.5 $*/

/*Modifications (in reverse order)

WBL 13 Nov 94  Make compatible with other code from Mike Calviou

WBL 13 Nov 94  netchk.for translated by f2c (version 19941108).
*/

#include "loadflow.h"

BOOL nodchk(int nn, int nl, int NNLK[NL], int NNLJ[NL], BOOL MAINT[NL],
	    /*output*/
	    BOOL splnod[NN])
{
    /* Local variables */
    int ib, n;
    int conect[nn+1];
    BOOL isolated = FALSE;

    /* Function Body */

    memset (conect,0,sizeof(conect));
    memset (splnod,0,sizeof(BOOL)*NN);

    for (ib = 1; ib <= nl; ++ib) {
	if (!MAINT[ib]) {
	    conect[NNLK[ib]] = conect[NNLK[ib]] + 1;
	    conect[NNLJ[ib]] = conect[NNLJ[ib]] + 1;
	}
    }

    for (n = 1; n <= nn; ++n) {
	if (conect[n] == 0) {
	    isolated  = TRUE;
	    splnod[n] = TRUE;
	}
    }
    return !isolated;
} /*end nodchk_ */
